/*
DHTML Context Menus
Version 1.0
Script by Will Martin
9 January 2001
selanit@atuan.com

This archive should include these files:
context-menus.js
context-menus.css
context-menus.html
context-menus-readme.txt
*/


/* Initialize browser variables. */
var NS4 = (document.layers)?1:0; // Test for Netscape 4+.
var KeepMenu = 0;
var xpos = 0;
var ypos = 0;

/*
InitClickDetection() must be called from the Body tag, like this:

<body onLoad="InitClickDetection();">

The function does what it says -- once the page has loaded, it starts 
checking for clicks.  Every time somebody clicks somewhere on the document, 
the browser notices and calls MouseClick() to handle the event.
*/
function InitClickDetection() {
	if (NS4){
		document.captureEvents(Event.CLICK); // Case sensitive, do not change case!
	}
	document.onclick = MouseClick; // No () in call to MouseClick, for some reason.
}

/*
When a user clicks someplace, MouseClick() logs the X/Y coordinates and stores them 
in the variables xpos and ypos.  If the place they clicked happens to be a link that 
brings up a menu, then PositionMenus() needs the xpos and ypos data to position the menu.

This function not referred to directly in the HTML document.
*/
function MouseClick(e){
	if (NS4) {
		xpos = e.pageX;
		ypos = e.pageY;
	} else {
		xpos = event.x + document.body.scrollLeft;
		ypos = event.y + document.body.scrollTop;
	}
	return true;
}

/*
Moves the relevant menu to the current coordinates of the mouse, as recorded by 
MouseClick().  PositionMenus() is called from within the PopUp() function, so it is 
never referred to directly in the HTML document.
*/
function PositionMenus(MenuName){
	if (NS4) {
		document.layers[MenuName].left = xpos;
		document.layers[MenuName].top = ypos;
	} else {
		document.all[MenuName].style.pixelLeft = xpos;
		document.all[MenuName].style.pixelTop = ypos;
	}
}

/*
PopUp() reveals or hides a given submenu.  MenuName specifies which 
menu should be altered, and "on" is a boolean value.  If the function 
is called with on specified as "1", then the menu is revealed.  If 
on is specified as "0" then the menu is hidden.  
*/
function PopUp (MenuName, on) {
	KeepMenu = 1; // This variable needed by HideDelay();

	PositionMenus(MenuName); // Bring menu to mouse's current position.

	if (on){ // Reveal menu.
		if (NS4) {
			document.layers[MenuName].visibility = "show";
		} else {
			document.all[MenuName].style.visibility = "visible";
		}
	} else { // Or, Conceal menu.
		if (NS4) {
			document.layers[MenuName].visibility = "hide";
		} else {
			document.all[MenuName].style.visibility = "hidden";
		}
	}
}

/*
This function Hides all submenus.  If you are getting error messages saying 
"Document.layers[...] not defined" or "Document.all[...] not defined" then 
you should check the names of the menus, which should be listed in the array 
called MenuList that is on the HTML document itself.
*/
/*
Hide() must cancel pending calls to HideDelay(), so that 
menus will not vanish milliseconds after they've appeared when a call to 
HideDelay() from previous events executes.

Hence the clearTimeout call.  The TimerID must be checked first to see if 
it's set, otherwise an error will be generated when the script tries to clear 
a timeout that hasn't been set.
*/
function Hide(){
	if (this.TimerID){
		window.clearTimeout(this.TimerID);
	}
	for (i = 0; i < MenuList.length; i++){ // Cycle through the list of menus and hide them.
		eval("PopUp('"+MenuList[i]+"', 0)");
	}
}


/*
HideDelay() is called from the OnMouseOut of those menu items that 
have sub-menus to pop up.  When a user moves off the parent link,
HideDelay() checks to see if KeepMenu is true, which it is because it 
was set by PopUp().  So, it sets KeepMenu to false and sets a timeout 
to call itself in half a second.  Meanwhile, if the user moves the mouse 
over the submenu that is being displayed, Extender() is called, which cancels 
the timeout request, leaving the menu in place.  

HideDelay() is also called from the OnMouseOut of the submenu, so that the 
submenu will vanish once someone has moved on to other things.
*/
function HideDelay(KeepMenu) {
	if (KeepMenu == 0){
		Hide();
	} else { 
		KeepMenu = 0;
		this.TimerID = window.setTimeout('HideDelay('+KeepMenu+')', 500);
	}
}

/*
Extender() is called from the table that each submenu is kept in, and 
also from each link in the submenu.  When it is called, it clears the 
existing Timeout call to HideDelay().

Netscape doesn't recognize OnMouseOver or OnMouseOut events for the 
<table> tag, so each table is encapsulated in a <layer> tag with the 
same calls to Extender() and HideDelay().  This ensures that the 
menus work the same in both Netscape and IE.
*/
function Extender(){
	if (this.TimerID){
		window.clearTimeout(this.TimerID);
	}
}